Sponsored Content
Full Discussion: SIGTERM failing in AIX
Operating Systems AIX SIGTERM failing in AIX Post 302998862 by Don Cragun on Thursday 8th of June 2017 06:45:59 PM
Old 06-08-2017
I presume that:
  1. the script that you showed us that you're trying to kill is not the actual code that you're trying to kill,
  2. that you are not the author of the code you're trying to kill (since you didn't know the trap was there), and
  3. that you didn't consult with the author of that script before trying to write code to kill it
.
One obvious reason why someone would add a trap command to ignore signals to a script that is expected to run for a while (i.e., more than a 1 instruction cycle) would be to keep scripts like yours from randomly killing them. Trying to ignore SIGSTOP and SIGKILL produces undefined results, but it is certainly a reasonable first attempt to keep a script running while the author of that script tracks down why their script is being terminated for no obvious reason.
 

10 More Discussions You Might Find Interesting

1. Programming

signals - SIGTERM

Hi all, I need some urgent help. we are using Dynix/ptx V4.5 on i386, have several processes and instances are running on the box round the clock.we increased the processes recently. We have coded to handle the signals in our programs. Recently, we noticed most of our processes are... (2 Replies)
Discussion started by: reddyb
2 Replies

2. HP-UX

make fuser send SIGTERM?

Hello, Nice forum BTW... anyway on to my question. I am trying to write a korn shell script that will shut down a java VM. The first challenge was how to figure out which java VM to kill, as there can be other java processes running at the same time. Then I discovered fuser. It says it... (4 Replies)
Discussion started by: adamides
4 Replies

3. Programming

How to implement SIGKILL and SIGTERM and print a message?

Hello, I am running a webserver that uses sockets, forks, and children. The parent process listens for connections and the child processes the information. I am trying to figure out why the code I have below SIGTERM, and SIGKILL never fire. I was messing around with the printfs and doesnt... (11 Replies)
Discussion started by: norelco55
11 Replies

4. Programming

the parent receive SIGTERM from its child (httpd) ?

the parent is a process manager in our design, and httpd service is one of its child processes, which is started in foreground mode (with "-D FOREGROUND" options) according to our requirements. when httpd service is started, one main httpd process and eight sub httpd processes can be found by... (4 Replies)
Discussion started by: aaronwong
4 Replies

5. Shell Programming and Scripting

How to detect SIGTERM,SIGKILL signal in UNIX

Dear All We have JBOSS server running on Linux we need to track Graceful Shutdown(SIGTERM) and Forceful Shutdown(SIGKILL) timestamp and write it into one file, I am new to UNIX Signal processing if is it possible how to detect it? We generally do $kill PID For Graceful... (5 Replies)
Discussion started by: mnmonu
5 Replies

6. Programming

Reliable management of signal SIGPIPE and SIGTERM

I' m note very expert in the reliable manage of signal... but in my server I must manage SIGPIPE for the socket and SIGTERM... I've wrote this but there is something wrong... Can someone explain me with some example the reliable management of signal?? This is what I've wrote in the server ... (2 Replies)
Discussion started by: italian_boy
2 Replies

7. AIX

FIREFOX Failing in AIX

Hi Guys, I tried running the firefox in AIX 6.1 and got the below error.. -bash-3.00# firefox Could not load program /usr/mozilla/firefox/firefox-bin: Could not load module /usr/mozilla/firefox/libxul.so. Dependent module /usr/lib/libgtk-x11-2.0.a(libgtk-x11-2.0.so.0) could not... (0 Replies)
Discussion started by: kkeng808
0 Replies

8. Shell Programming and Scripting

Current instance of Shell ignoring SIGTERM

Hello. Could anyone tell me how can I configure a instance of Shell to ignore the SIGTERM signal? I would really appreciate. Thanks. (6 Replies)
Discussion started by: razolo13
6 Replies

9. Shell Programming and Scripting

ksh child process not ignoring SIGTERM

My ksh version is ksh93- =>rpm -qa | grep ksh ksh-20100621-3.fc13.i686 I have a simple script which is as below - #cat test_sigterm.sh - #!/bin/ksh trap 'echo "removing"' QUIT while read line do sleep 20 done I am Executing the script From Terminal 1 - 1. The ksh is started... (3 Replies)
Discussion started by: rpoornar
3 Replies

10. AIX

Failing to add new NetApp disk AIX 7.1 - but no error

Hello, AIX 7.1 - several NetApp disks already running. Trying to install a new one. Storage folks provision it. I run cfgmgr - nothing. no new disks show up in "lsdev", "sanlun lun show" shows no new device. No errors, just nothing. Storage guys disconnect it and attaches to another aix server -... (5 Replies)
Discussion started by: sid
5 Replies
TRAP(P) 						     POSIX Programmer's Manual							   TRAP(P)

NAME
trap - trap signals SYNOPSIS
trap [action condition ...] DESCRIPTION
If action is '-' , the shell shall reset each condition to the default value. If action is null ( "" ), the shell shall ignore each speci- fied condition if it arises. Otherwise, the argument action shall be read and executed by the shell when one of the corresponding condi- tions arises. The action of trap shall override a previous action (either default action or one explicitly set). The value of "$?" after the trap action completes shall be the value it had before trap was invoked. The condition can be EXIT, 0 (equivalent to EXIT), or a signal specified using a symbolic name, without the SIG prefix, as listed in the tables of signal names in the <signal.h> header defined in the Base Definitions volume of IEEE Std 1003.1-2001, Chapter 13, Headers; for example, HUP, INT, QUIT, TERM. Implementations may permit names with the SIG prefix or ignore case in signal names as an extension. Setting a trap for SIGKILL or SIGSTOP produces undefined results. The environment in which the shell executes a trap on EXIT shall be identical to the environment immediately after the last command exe- cuted before the trap on EXIT was taken. Each time trap is invoked, the action argument shall be processed in a manner equivalent to: eval action Signals that were ignored on entry to a non-interactive shell cannot be trapped or reset, although no error need be reported when attempt- ing to do so. An interactive shell may reset or catch signals ignored on entry. Traps shall remain in place for a given shell until explic- itly changed with another trap command. When a subshell is entered, traps that are not being ignored are set to the default actions. This does not imply that the trap command can- not be used within the subshell to set new traps. The trap command with no arguments shall write to standard output a list of commands associated with each condition. The format shall be: "trap -- %s %s ... ", <action>, <condition> ... The shell shall format the output, including the proper use of quoting, so that it is suitable for reinput to the shell as commands that achieve the same trapping results. For example: save_traps=$(trap) ... eval "$save_traps" XSI-conformant systems also allow numeric signal numbers for the conditions corresponding to the following signal names: Signal Number Signal Name 1 SIGHUP 2 SIGINT 3 SIGQUIT 6 SIGABRT 9 SIGKILL 14 SIGALRM 15 SIGTERM The trap special built-in shall conform to the Base Definitions volume of IEEE Std 1003.1-2001, Section 12.2, Utility Syntax Guidelines. OPTIONS
None. OPERANDS
See the DESCRIPTION. STDIN
Not used. INPUT FILES
None. ENVIRONMENT VARIABLES
None. ASYNCHRONOUS EVENTS
Default. STDOUT
See the DESCRIPTION. STDERR
The standard error shall be used only for diagnostic messages. OUTPUT FILES
None. EXTENDED DESCRIPTION
None. EXIT STATUS
If the trap name or number is invalid, a non-zero exit status shall be returned; otherwise, zero shall be returned. For both interac- tive and non-interactive shells, invalid signal names or numbers shall not be considered a syntax error and do not cause the shell to abort. CONSEQUENCES OF ERRORS
Default. The following sections are informative. APPLICATION USAGE
None. EXAMPLES
Write out a list of all traps and actions: trap Set a trap so the logout utility in the directory referred to by the HOME environment variable executes when the shell terminates: trap '$HOME/logout' EXIT or: trap '$HOME/logout' 0 Unset traps on INT, QUIT, TERM, and EXIT: trap - INT QUIT TERM EXIT RATIONALE
Implementations may permit lowercase signal names as an extension. Implementations may also accept the names with the SIG prefix; no known historical shell does so. The trap and kill utilities in this volume of IEEE Std 1003.1-2001 are now consistent in their omission of the SIG prefix for signal names. Some kill implementations do not allow the prefix, and kill -l lists the signals without prefixes. Trapping SIGKILL or SIGSTOP is syntactically accepted by some historical implementations, but it has no effect. Portable POSIX applications cannot attempt to trap these signals. The output format is not historical practice. Since the output of historical trap commands is not portable (because numeric signal values are not portable) and had to change to become so, an opportunity was taken to format the output in a way that a shell script could use to save and then later reuse a trap if it wanted. The KornShell uses an ERR trap that is triggered whenever set -e would cause an exit. This is allowable as an extension, but was not man- dated, as other shells have not used it. The text about the environment for the EXIT trap invalidates the behavior of some historical versions of interactive shells which, for example, close the standard input before executing a trap on 0. For example, in some historical interactive shell sessions the following trap on 0 would always print "--" : trap 'read foo; echo "-$foo-"' 0 FUTURE DIRECTIONS
None. SEE ALSO
Special Built-In Utilities COPYRIGHT
Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technol- ogy -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html . IEEE
/The Open Group 2003 TRAP(P)
All times are GMT -4. The time now is 12:59 AM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy